Ruby method refinement memory leak
Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 3.0: UNKNOWN, 3.1: REQUIRED, 3.2:

DONE

Description

GitHub pull request: https://github.com/ruby/ruby/pull/8487

When method redefinitions happen, sometimes the final definition does not get cleaned up,

Reproducable with the same script from: https://bugs.ruby-lang.org/issues/19894

10.times do

  20_000.times do

    $c = Class.new do

      def foo; end

    end

    $m = Module.new do

      refine $c do

        def foo; end

      end

    end

    Class.new do

      using $m

      def initialize

        o = $c.new

        o.method(:foo).unbind

      end

    end.new

  end

  puts `ps -o rss= -p #{$$}`

end
Associated revisions

Revision 8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763 - 09/22/2023 01:44 PM - HParker (Adam Hess)

[Bug #19896]

fix memory leak in vm_method

This introduces a unified reference_count to clarify who is referencing a method.

This also allows us to treat the refinement method as the def owner since it counts itself as a reference

Co-authored-by: Peter Zhu peter@peterzhu.ca

Revision 8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763 - 09/22/2023 01:44 PM - HParker (Adam Hess)

[Bug #19896]

fix memory leak in vm_method

This introduces a unified reference_count to clarify who is referencing a method.

This also allows us to treat the refinement method as the def owner since it counts itself as a reference

Co-authored-by: Peter Zhu peter@peterzhu.ca

Revision 8b236e0c - 09/22/2023 01:44 PM - HParker (Adam Hess)

[Bug #19896]

fix memory leak in vm_method

This introduces a unified reference_count to clarify who is referencing a method.

This also allows us to treat the refinement method as the def owner since it counts itself as a reference

Co-authored-by: Peter Zhu peter@peterzhu.ca

Revision 97b7070ebd5493de8d3a6a9b0ecc91bef5068d3f - 09/30/2023 04:46 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763: [Backport #19896]

    [Bug #19896]

    fix memory leak in vm_method

    This introduces a unified reference_count to clarify who is referencing a method.

    This also allows us to treat the refinement method as the def owner since it counts itself as a reference

    Co-authored-by: Peter Zhu <peter@peterzhu.ca>

    ---

     gc.c                     |   4 +-

     method.h                 |   6 +--

     rjit_c.rb                |   6 +--

     test/ruby/test_module.rb |   4 +-

     vm_insnhelper.c          |   2 +-

     vm_method.c              | 105 +++++++++++++++++++----------------------------

     6 files changed, 54 insertions(+), 73 deletions(-)

Revision 97b7070ebd5493de8d3a6a9b0ecc91bef5068d3f - 09/30/2023 04:46 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763: [Backport #19896]

    [Bug #19896]

    fix memory leak in vm_method

    This introduces a unified reference_count to clarify who is referencing a method.

    This also allows us to treat the refinement method as the def owner since it counts itself as a reference

    Co-authored-by: Peter Zhu <peter@peterzhu.ca>

    ---
     gc.c                     |   4 +-

     method.h                 |   6 +--

     rjit_c.rb                |   6 +--

     test/ruby/test_module.rb |   4 +-

     vm_insnhelper.c          |   2 +-

     vm_method.c              | 105 +++++++++++++++++++----------------------------

     6 files changed, 54 insertions(+), 73 deletions(-)

Revision 97b7070e - 09/30/2023 04:46 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763: [Backport #19896]

    [Bug #19896]

    fix memory leak in vm_method

    This introduces a unified reference_count to clarify who is referencing a method.

    This also allows us to treat the refinement method as the def owner since it counts itself as a reference

    Co-authored-by: Peter Zhu <peter@peterzhu.ca>

    ---

     gc.c                     |   4 +-

     method.h                 |   6 +--

     rjit_c.rb                |   6 +--

     test/ruby/test_module.rb |   4 +-

     vm_insnhelper.c          |   2 +-

     vm_method.c              | 105 +++++++++++++++++++----------------------------

     6 files changed, 54 insertions(+), 73 deletions(-)

History

#1 - 09/20/2023 06:57 PM - peterzhu2118 (Peter Zhu)

- Backport changed from 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2: UNKNOWN to 3.0: UNKNOWN, 3.1: REQUIRED, 3.2: REQUIRED

#2 - 09/22/2023 01:58 PM - HParker (Adam Hess)

- Status changed from Open to Closed

Applied in changeset git|8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763.

[Bug #19896]

fix memory leak in vm_method

This introduces a unified reference_count to clarify who is referencing a method.

This also allows us to treat the refinement method as the def owner since it counts itself as a reference

Co-authored-by: Peter Zhu peter@peterzhu.ca

#3 - 09/30/2023 07:07 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.0: UNKNOWN, 3.1: REQUIRED, 3.2: REQUIRED to 3.0: UNKNOWN, 3.1: REQUIRED, 3.2: DONE

ruby_3_2 97b7070ebd5493de8d3a6a9b0ecc91bef5068d3f merged revision(s) 8b236e0c66da8f92e9fc33de66cfbc8e4b0c0763.
